Pagination

In cases where the total result set of knowledge objects is greater than the page size, the Cisco Observability Platform Knowledge Store API returns a link header that can be used to fetch the next page of results.

The Knowledge Store API supports three query parameters related to pagination:

  • Order data in ascending or descending order.
  • Limit the number of rows - define the page size.
  • Use the continuation link in the response header to retrieve the previous and/or next page with data.

Max

The default page size is 200 results. If you want your page size to be smaller or larger, specify the max query parameter.

If the number of results is greater than max, a link header is returned in the response. This link header can be used to fetch the next or previous page of results.

Example Request

The following request displays an example request for a page size of 10 results:

curl --location 'fso-devplat.observe.appdynamics.com/knowledge-store/v1/objects/fmm:metric?max=10' \
--header 'Authorization: <Access Token>' \
--header 'layer-id: k8s' \
--header 'layer-type: SOLUTION' \

Example Response

The total field in the response specifies the total number of knowledge objects returned for the query. The items array returns the number of items specified with the max query parameter.

Expand
  {
    "total": 70,
    "items": [
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:cpu.usage",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "cpu.usage",
                "type": "double",
                "unit": "{cores}",
                "category": "sum",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "distribution",
                "description": "Number of cpu cores used",
                "displayName": "CPU Cores Usage",
                "isMonotonic": false,
                "aggregationTemporality": "delta"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-04-01T12:59:43.813Z",
            "updatedAt": "2023-04-01T12:59:43.813Z",
            "objectType": "fmm:metric"
        },
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:cpu.limits",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "cpu.limits",
                "type": "double",
                "unit": "{cores}",
                "category": "sum",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "distribution",
                "description": "Maximum cpu cores allowed",
                "displayName": "CPU Limits",
                "isMonotonic": false,
                "aggregationTemporality": "delta"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-04-01T12:59:43.823Z",
            "updatedAt": "2023-04-01T12:59:43.823Z",
            "objectType": "fmm:metric"
        },
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:cpu.limits.usage",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "cpu.limits.usage",
                "type": "double",
                "unit": "{cores}",
                "category": "sum",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "distribution",
                "description": "Number of cpu cores used when limits specified",
                "displayName": "CPU Limits Usage",
                "isMonotonic": false,
                "aggregationTemporality": "delta"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-04-01T12:59:43.831Z",
            "updatedAt": "2023-04-01T12:59:43.831Z",
            "objectType": "fmm:metric"
        },
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:cpu.requests.usage",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "cpu.requests.usage",
                "type": "double",
                "unit": "{cores}",
                "category": "sum",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "distribution",
                "description": "Number of cpu cores used when requests specified",
                "displayName": "CPU Requests Usage",
                "isMonotonic": false,
                "aggregationTemporality": "delta"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-04-01T12:59:43.845Z",
            "updatedAt": "2023-04-01T12:59:43.845Z",
            "objectType": "fmm:metric"
        },
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:cpu.requests",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "cpu.requests",
                "type": "double",
                "unit": "{cores}",
                "category": "sum",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "distribution",
                "description": "Minimum cpu cores required",
                "displayName": "CPU Requests",
                "isMonotonic": false,
                "aggregationTemporality": "delta"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-04-01T12:59:43.854Z",
            "updatedAt": "2023-04-01T12:59:43.854Z",
            "objectType": "fmm:metric"
        },
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:cpu.throttled_count",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "cpu.throttled_count",
                "type": "long",
                "unit": "{periods}",
                "category": "current",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "gauge",
                "description": "Number of scheduled CPU periods where the container CPU was throttled",
                "displayName": "CPU Throttle Count",
                "isMonotonic": false,
                "aggregationTemporality": "unspecified"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-04-01T12:59:43.863Z",
            "updatedAt": "2023-04-01T12:59:43.863Z",
            "objectType": "fmm:metric"
        },
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:memory.usage",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "memory.usage",
                "type": "long",
                "unit": "By",
                "category": "sum",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "distribution",
                "description": "Total memory used",
                "displayName": "Memory Usage",
                "isMonotonic": false,
                "aggregationTemporality": "delta"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-04-01T12:59:43.871Z",
            "updatedAt": "2023-04-01T12:59:43.871Z",
            "objectType": "fmm:metric"
        },
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:memory.limits.usage",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "memory.limits.usage",
                "type": "long",
                "unit": "By",
                "category": "sum",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "distribution",
                "description": "Total memory used when limits specified",
                "displayName": "Memory Limits Usage",
                "isMonotonic": false,
                "aggregationTemporality": "delta"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-04-01T12:59:43.880Z",
            "updatedAt": "2023-04-01T12:59:43.880Z",
            "objectType": "fmm:metric"
        },
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:memory.requests.usage",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "memory.requests.usage",
                "type": "long",
                "unit": "By",
                "category": "sum",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "distribution",
                "description": "Total memory used when requests specified",
                "displayName": "Memory Requests Usage",
                "isMonotonic": false,
                "aggregationTemporality": "delta"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-04-01T12:59:43.889Z",
            "updatedAt": "2023-04-01T12:59:43.889Z",
            "objectType": "fmm:metric"
        },
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:memory.limits",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "memory.limits",
                "type": "long",
                "unit": "By",
                "category": "sum",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "distribution",
                "description": "Maximum amount of memory allowed to be consumed",
                "displayName": "Memory Limits",
                "isMonotonic": false,
                "aggregationTemporality": "delta"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-04-01T12:59:43.906Z",
            "updatedAt": "2023-04-01T12:59:43.906Z",
            "objectType": "fmm:metric"
        }
    ]
}

Continuation

The full list of response headers from the previous request is shown in the following code block. The link header is < link: </v1/objects/fmm:metric?max=10&cursor=MTA=>; rel="next".

In this example, the link header can be used to fetch the next page. Subsequent requests should return next and prev links. When you navigate to the last page of results, only the prev link will be returned. See RFC 5988.

Example Response Headers

< HTTP/2 200 
< date: Tue, 02 May 2023 17:58:27 GMT
< content-type: application/json; charset=utf-8
< content-length: 5711
< x-powered-by: Express
< access-control-allow-origin: *
< link: </v1beta/objects/fmm:metric?max=10&cursor=MTA=>; rel="next"
< x-envoy-upstream-service-time: 4147
< server: istio-envoy
< strict-transport-security: max-age=31536000; includeSubDomains
< x-content-type-options: nosniff
< x-frame-options: SAMEORIGIN
< strip-filter: executed
< strip-filter-cookie-status: Neither ser_app nor ak_bmsc found, hence not stripped; org-cookie-len 121;new-cookie-len 122;
< 

Example Request Using next

The following request uses the next link header:

  curl --location 'https://fso-devplat.observe.appdynamics.com/knowledge-store/v1/objects/fmm:metric?max=10&cursor=MTA%3D' \
--header 'Authorization: <Access Token>' \
--header 'layer-id: k8s' \
--header 'layer-type: SOLUTION' \

Example Response Headers Using next

The following response displays after using the next link header:

   < HTTP/2 200 
   < date: Tue, 02 May 2023 21:38:42 GMT
   < content-type: application/json; charset=utf-8
   < content-length: 5748
   < x-powered-by: Express
   < access-control-allow-origin: *
   < link: </v1beta/objects/fmm:metric?max=10&cursor=MjA=>; rel="next", </v1beta/objects/fmm:metric?max=10&cursor=MA==>; rel="prev"
   < x-envoy-upstream-service-time: 18
   < server: istio-envoy
   < strict-transport-security: max-age=31536000; includeSubDomains
   < x-content-type-options: nosniff
   < x-frame-options: SAMEORIGIN
   < strip-filter: executed
   < strip-filter-cookie-status: No cookie header found

Example Response Body Using next

Expand
  {
    "total": 70,
    "items": [
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:memory.requests",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "memory.requests",
                "type": "long",
                "unit": "By",
                "category": "sum",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "distribution",
                "description": "Minimum amount of memory required",
                "displayName": "Memory Requests",
                "isMonotonic": false,
                "aggregationTemporality": "delta"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-03-28T04:12:32.300Z",
            "updatedAt": "2023-03-28T04:12:32.300Z",
            "objectType": "fmm:metric"
        },
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:storage.limits",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "storage.limits",
                "type": "long",
                "unit": "By",
                "category": "current",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "gauge",
                "description": "Maximum amount of storage capacity provisioned",
                "displayName": "PV Storage Limit",
                "isMonotonic": false,
                "aggregationTemporality": "unspecified"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-03-28T04:12:32.307Z",
            "updatedAt": "2023-03-28T04:12:32.307Z",
            "objectType": "fmm:metric"
        },
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:storage.requests",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "storage.requests",
                "type": "long",
                "unit": "By",
                "category": "sum",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "distribution",
                "description": "Minimum amount of storage required",
                "displayName": "PVC Storage Requests",
                "isMonotonic": false,
                "aggregationTemporality": "delta"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-03-28T04:12:32.315Z",
            "updatedAt": "2023-03-28T04:12:32.315Z",
            "objectType": "fmm:metric"
        },
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:storage.requests.usage",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "storage.requests.usage",
                "type": "long",
                "unit": "By",
                "category": "sum",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "distribution",
                "description": "Amount of storage used",
                "displayName": "PVC Storage Requests Usage",
                "isMonotonic": false,
                "aggregationTemporality": "delta"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-03-28T04:12:32.328Z",
            "updatedAt": "2023-03-28T04:12:32.328Z",
            "objectType": "fmm:metric"
        },
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:cpu.allocatable",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "cpu.allocatable",
                "type": "double",
                "unit": "{cores}",
                "category": "sum",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "distribution",
                "description": "Maximum CPU cores available for pods",
                "displayName": "CPU Allocatable",
                "isMonotonic": false,
                "aggregationTemporality": "delta"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-03-28T04:12:32.338Z",
            "updatedAt": "2023-03-28T04:12:32.338Z",
            "objectType": "fmm:metric"
        },
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:memory.allocatable",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "memory.allocatable",
                "type": "long",
                "unit": "By",
                "category": "sum",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "distribution",
                "description": "Maximum memory available for pods",
                "displayName": "Memory Allocatable",
                "isMonotonic": false,
                "aggregationTemporality": "delta"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-03-28T04:12:32.348Z",
            "updatedAt": "2023-03-28T04:12:32.348Z",
            "objectType": "fmm:metric"
        },
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:storage.allocatable",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "storage.allocatable",
                "type": "long",
                "unit": "By",
                "category": "current",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "gauge",
                "description": "Maximum storage available for pods",
                "displayName": "Storage Allocatable",
                "isMonotonic": false,
                "aggregationTemporality": "unspecified"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-03-28T04:12:32.354Z",
            "updatedAt": "2023-03-28T04:12:32.354Z",
            "objectType": "fmm:metric"
        },
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:pods.allocatable",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "pods.allocatable",
                "type": "long",
                "unit": "{pods}",
                "category": "current",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "gauge",
                "description": "Maximum number of pods which can be run",
                "displayName": "Pods Allocatable",
                "isMonotonic": false,
                "aggregationTemporality": "unspecified"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-03-28T04:12:32.361Z",
            "updatedAt": "2023-03-28T04:12:32.361Z",
            "objectType": "fmm:metric"
        },
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:memory.pressure",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "memory.pressure",
                "type": "long",
                "unit": "1",
                "category": "sum",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "distribution",
                "description": "Indicates kubelet is under pressure due to insufficient memory",
                "displayName": "Memory Pressure",
                "isMonotonic": false,
                "aggregationTemporality": "delta"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-03-28T04:12:32.368Z",
            "updatedAt": "2023-03-28T04:12:32.368Z",
            "objectType": "fmm:metric"
        },
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:disk.pressure",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "disk.pressure",
                "type": "long",
                "unit": "1",
                "category": "sum",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "distribution",
                "description": "Indicates kubelet is under pressure due to insufficient disk",
                "displayName": "Disk Pressure",
                "isMonotonic": false,
                "aggregationTemporality": "delta"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-03-28T04:12:32.375Z",
            "updatedAt": "2023-03-28T04:12:32.375Z",
            "objectType": "fmm:metric"
        }
    ]
}

Order/Sort

By default, data is sorted by the createdAt field. To sort by the id field, specify the id field using the sort query parameter. Ensure that this field exists on the knowledge object.

Limitation: You can only sort by the `createdAt` and `id` fields. Sorting by other fields is not currently supported.

By default, results are ordered in ascending order. You can specify descending order by using the order query parameter. Only asc and desc orders are currently supported.

Example Request

  curl --location 'https://fso-devplat.observe.appdynamics.com/knowledge-store/v1/objects/fmm:metric?max=10&sort=id&order=desc' \
--header 'layer-type: SOLUTION' \
--header 'appd-pid: VVNFUg==' \
--header 'appd-pty: U0VSVklDRQ==' \
--header 'layer-id: k8s' \
--header 'Authorization: <Access Token>' \

Example Response Body

Expand
{
    "total": 70,
    "items": [
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:storage.requests.usage",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "storage.requests.usage",
                "type": "long",
                "unit": "By",
                "category": "sum",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "distribution",
                "description": "Amount of storage used",
                "displayName": "PVC Storage Requests Usage",
                "isMonotonic": false,
                "aggregationTemporality": "delta"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-03-28T04:12:32.328Z",
            "updatedAt": "2023-03-28T04:12:32.328Z",
            "objectType": "fmm:metric"
        },
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:storage.requests",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "storage.requests",
                "type": "long",
                "unit": "By",
                "category": "sum",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "distribution",
                "description": "Minimum amount of storage required",
                "displayName": "PVC Storage Requests",
                "isMonotonic": false,
                "aggregationTemporality": "delta"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-03-28T04:12:32.315Z",
            "updatedAt": "2023-03-28T04:12:32.315Z",
            "objectType": "fmm:metric"
        },
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:storage.limits",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "storage.limits",
                "type": "long",
                "unit": "By",
                "category": "current",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "gauge",
                "description": "Maximum amount of storage capacity provisioned",
                "displayName": "PV Storage Limit",
                "isMonotonic": false,
                "aggregationTemporality": "unspecified"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-03-28T04:12:32.307Z",
            "updatedAt": "2023-03-28T04:12:32.307Z",
            "objectType": "fmm:metric"
        },
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:storage.allocatable",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "storage.allocatable",
                "type": "long",
                "unit": "By",
                "category": "current",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "gauge",
                "description": "Maximum storage available for pods",
                "displayName": "Storage Allocatable",
                "isMonotonic": false,
                "aggregationTemporality": "unspecified"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-03-28T04:12:32.354Z",
            "updatedAt": "2023-03-28T04:12:32.354Z",
            "objectType": "fmm:metric"
        },
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:resource_quota.storage.requests.usage",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "resource_quota.storage.requests.usage",
                "type": "long",
                "unit": "By",
                "category": "sum",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "distribution",
                "description": "Total storage request used when storage quota configured ",
                "displayName": "Storage Quota Requests Usage",
                "isMonotonic": false,
                "aggregationTemporality": "delta"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-03-28T04:12:32.542Z",
            "updatedAt": "2023-03-28T04:12:32.542Z",
            "objectType": "fmm:metric"
        },
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:resource_quota.storage.requests",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "resource_quota.storage.requests",
                "type": "long",
                "unit": "By",
                "category": "sum",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "distribution",
                "description": "Maximum allowed sum of storage requests",
                "displayName": "Storage Quota Requests",
                "isMonotonic": false,
                "aggregationTemporality": "delta"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-03-28T04:12:32.530Z",
            "updatedAt": "2023-03-28T04:12:32.530Z",
            "objectType": "fmm:metric"
        },
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:resource_quota.pvc.requests.usage",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "resource_quota.pvc.requests.usage",
                "type": "long",
                "unit": "{pvcs}",
                "category": "sum",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "distribution",
                "description": "Number of pvc requests used when resource quota is configured",
                "displayName": "PVC Quota Requests Usage",
                "isMonotonic": false,
                "aggregationTemporality": "delta"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-03-28T04:12:32.517Z",
            "updatedAt": "2023-03-28T04:12:32.517Z",
            "objectType": "fmm:metric"
        },
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:resource_quota.pvc.requests",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "resource_quota.pvc.requests",
                "type": "long",
                "unit": "{pvcs}",
                "category": "sum",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "distribution",
                "description": "Total pvc requests allowed",
                "displayName": "PVC Quota Requests",
                "isMonotonic": false,
                "aggregationTemporality": "delta"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-03-28T04:12:32.508Z",
            "updatedAt": "2023-03-28T04:12:32.508Z",
            "objectType": "fmm:metric"
        },
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:resource_quota.memory.requests.usage",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "resource_quota.memory.requests.usage",
                "type": "long",
                "unit": "By",
                "category": "sum",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "distribution",
                "description": "Total memory used when resource quota request configured",
                "displayName": "Memory Quota Requests Usage",
                "isMonotonic": false,
                "aggregationTemporality": "delta"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-03-28T04:12:32.492Z",
            "updatedAt": "2023-03-28T04:12:32.492Z",
            "objectType": "fmm:metric"
        },
        {
            "layerType": "SOLUTION",
            "id": "k8s@1:resource_quota.memory.requests",
            "layerId": "k8s",
            "data": {
                "kind": "metric",
                "name": "resource_quota.memory.requests",
                "type": "long",
                "unit": "By",
                "category": "sum",
                "namespace": {
                    "name": "k8s",
                    "version": 1
                },
                "contentType": "distribution",
                "description": "Maximum allowed sum of all memory requests",
                "displayName": "Memory Quota Requests",
                "isMonotonic": false,
                "aggregationTemporality": "delta"
            },
            "objectMimeType": "application/json",
            "targetObjectId": null,
            "patch": null,
            "objectVersion": 1,
            "createdAt": "2023-03-28T04:12:32.476Z",
            "updatedAt": "2023-03-28T04:12:32.476Z",
            "objectType": "fmm:metric"
        }
    ]
}

Example Response Headers

All query parameters supplied to the initial request are included (in addition to the cursor parameter) in the link header returned in the response.

< HTTP/2 200 
< date: Tue, 02 May 2023 21:44:03 GMT
< content-type: application/json; charset=utf-8
< content-length: 6014
< x-powered-by: Express
< access-control-allow-origin: *
< link: </v1beta/objects/fmm:metric?sort=id&order=desc&max=10&cursor=MTA=>; rel="next"
< x-envoy-upstream-service-time: 21
< server: istio-envoy
< strict-transport-security: max-age=31536000; includeSubDomains
< x-content-type-options: nosniff
< x-frame-options: SAMEORIGIN
< strip-filter: executed
< strip-filter-cookie-status: No cookie header found